/**
 *  Este programa é software livre; você pode redistribuí-lo e/ou
 *  modificá-lo sob os termos da Licença Pública Geral GNU, conforme
 *  publicada pela Free Software Foundation; tanto a versão 2 da
 *  Licença como (a seu critério) qualquer versão mais nova.
 *
 *  Este programa é distribuído na expectativa de ser útil, mas SEM
 *  QUALQUER GARANTIA; sem mesmo a garantia implícita de
 *  COMERCIALIZAÇÃO ou de ADEQUAÇÃO A QUALQUER PROPÓSITO EM
 *  PARTICULAR. Consulte a Licença Pública Geral GNU para obter mais
 *  detalhes.
 *
 *  Você deve ter recebido uma cópia da Licença Pública Geral GNU
 *  junto com este programa; se não, escreva para a Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 *  02111-1307, USA.
 * 
 *  Prof. Emerson Ribeiro de Mello (2011)
 *  mello@ifsc.edu.br
 */
package jogo;

import principal.JavaBomber;
import java.awt.event.ActionEvent;
import java.awt.Canvas;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.util.ArrayList;
import java.util.Random;
import javax.swing.ImageIcon;
import javax.swing.Timer;
import principal.Recomecar;

/**
 * Essa clase contém a lógica principal do Jogo. A atualização da tela é feita
 * através de o Timer do pacote Swing. Por este motivo, essa classe tem que
 * implementar a Interface ActionListener
 * Essa classe herda de Canvas, pois a classe Canvas é ideal para fazer desenhos
 * e permite usufrir o bufferStrategy para melhorar a taxa de atualização da tela
 * 
 * @author Emerson Ribeiro de Mello
 */
public class JogoTimer extends Canvas implements ActionListener {
    //criar um outro tijolo, no poderes aleatorios eu carrego ele e depois muda-lo para uma 'skill'

    public JavaBomber framePrincipal; // frame principal do jogo
    protected Jogador jog1; // Jogador1
    protected Jogador jog2; // Jogador2
    public Timer timer; // Timer responsável pela atualização do jogo
    public int larguraBloco; // Dimensao dos personabens, fundos. É 40
    public int colunas; // total de colunas na matriz do jogo
    public int linhas; // total de linhas na matriz do jogo
    protected Image imgcenarios[]; // contém as imagens de fundo do cenário
    private int taxaDeAtualizacao; // a cada N milisegundos a tela é redesenhada
    protected int poder = 0;
    // 0 = ferro
    // 1 = tijolo
    // 2 = vazio
    // 3 = tijolo c/ poder
    // 4 = bomba+
    // 5 = fogo+
    // 6 = 
    // 7 = 
    // 8 = 
    // 9 = 
    // ...
    Random aleatorio;
    Random locaisPoderes;
    public short[][] cenario = { //11x17 (linha,coluna)
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
        {0, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 0},
        {0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0},
        {0, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 0},
        {0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0},
        {0, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 0},
        {0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0},
        {0, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 0},
        {0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0},
        {0, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 0},
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
    };
    protected int cima;
    protected String baixo;
    protected String esquerda;
    protected String direita;
    protected String atirar;
    public KeyEvent e;
    public String ganhador;
    private int vitorias1;
    private int vitorias2;
    public boolean novo = false;

    public JogoTimer(JavaBomber p) {
        super();
        this.framePrincipal = p;
        this.setBackground(Color.GRAY);
        this.setIgnoreRepaint(true); // para melhorar a velocidade do redesenho
        this.larguraBloco = 40;
        this.colunas = 17;
        this.linhas = 11;
        this.taxaDeAtualizacao = 100;
        this.imgcenarios = new Image[12];
        this.imgcenarios[0] = (new ImageIcon(this.getClass().getResource("/imagens/ferro.png"))).getImage();
        this.imgcenarios[1] = (new ImageIcon(this.getClass().getResource("/imagens/tijolo.png"))).getImage();
        this.imgcenarios[3] = (new ImageIcon(this.getClass().getResource("/imagens/tijolo.png"))).getImage();
        this.imgcenarios[4] = (new ImageIcon(this.getClass().getResource("/imagens/bomba+.png"))).getImage();
        this.imgcenarios[5] = (new ImageIcon(this.getClass().getResource("/imagens/fogo.png"))).getImage();
        this.imgcenarios[6] = (new ImageIcon(this.getClass().getResource("/imagens/rato.png"))).getImage();
        this.imgcenarios[7] = (new ImageIcon(this.getClass().getResource("/imagens/gato.png"))).getImage();
        this.imgcenarios[8] = (new ImageIcon(this.getClass().getResource("/imagens/vida1.png"))).getImage();
        this.aleatorio = new Random();
    }

    /**
     * Método invocado para iniciar a partida
     */
    public void comecaOJogo() {
        if (this.timer != null) {
            this.timer.stop();

        }
        if (novo) {
            vitorias1 = 0;
            vitorias2 = 0;
        }
            // criando o Timer com taxa de atualização de N milisegundos
            this.timer = new Timer(taxaDeAtualizacao, this);

            // criando 2 buffer para acelerar a taxa de desenho
            createBufferStrategy(2);
            cenarioAleatorio();

            // KeyEvent possui codigos para as teclas. Por exemplo, para obter
            // o codigo da tecla 'seta para cima' basta invocar KeyEvent.VK_UP
            // Veja o uso do KeyEvent na criacao dos jogadores abaixo
            // criando Jogador 1
            this.jog1 = new Jogador(this, "azul.png", 1, 1,
                    KeyEvent.VK_UP, KeyEvent.VK_DOWN,
                    KeyEvent.VK_RIGHT, KeyEvent.VK_LEFT, KeyEvent.VK_SPACE/*,
                    framePrincipal.jLX1J1, framePrincipal.jLY1J1*/);

            // criando Jogador 2
            this.jog2 = new Jogador(this, "vermelho.png", 15, 9,
                    KeyEvent.VK_W, KeyEvent.VK_S,
                    KeyEvent.VK_D, KeyEvent.VK_A, KeyEvent.VK_1);

            // Disparando o timer para começar a atualização do Loop principal do Jogo
            // Todo o conteúdo do método actionPerformed dessa classe será executado
            // a cada 60 milisegundos.
            this.timer.start();
        
    }

    public void pausarJogo() {
        this.timer.stop();
    }

    public void voltarAoJogo() {
        this.timer.start();
    }

    public void reiniciarJogo() {
        comecaOJogo();
    }

    public void configuraTeclas(int cima, String baixo, String esq, String direita, String atira) {
        this.cima = 0;
        this.baixo = "VK_UP";
        this.esquerda = esq;
        this.direita = direita;
        this.atirar = atira;
    }

    /**
     * Principal METODO do JOGO, pois e' aqui que fica a logica que fara':
     * - processamento da logica do jogo (morreu, disparou, etc..)
     * - atualizar as coordenadas dos elementos na tela para o proximo redesenho
     * - redesenhar os elementos na tela
     * 
     * Este método é invocado a cada N milisegundos pelo Timer
     * @param e 
     */
    @Override
    public void actionPerformed(ActionEvent e) {
        this.framePrincipal.teclado.poll(); // processa os eventos no teclado
        this.processarLogica(); // atualiza as coordenadas dos elementos
        this.renderizar(); // desenha os elementos no buffer de desenho
        this.desenhar(); // faz a troca do buffer de desenho pelo buffer de apresentacao

        framePrincipal.jLX2J1.setText("" + this.jog1.vidas);
        framePrincipal.jLX2J2.setText("" + this.jog2.vidas);
        framePrincipal.jLabel3.setText("" + this.jog1.qntdBombas);
        framePrincipal.jLabel4.setText("" + this.jog2.qntdBombas);
        framePrincipal.jLabel10.setText("" + this.jog1.tamFogo);
        framePrincipal.jLabel13.setText("" + this.jog2.tamFogo);
        framePrincipal.jLabel17.setText("" + this.vitorias1);
        framePrincipal.jLabel19.setText("" + this.vitorias2);
        
    }
    
    /**
     * Atualiza as coordenadas/estados de todos os elementos presentes no jogo
     * No caso, somente 2 jogadores, mas aqui pode-se colocar qualquer outro
     * elemento que venha a ser incluido no jogo
     */
    public void processarLogica() {
        //Chama o atualizar dos elementos
        if (this.jog1 != null) {
            this.jog1.atualizar();
        }
        if (this.jog2 != null) {
            this.jog2.atualizar();
        }
    }

    /**
     * Renderiza no buffer secundário todos os elementos já com suas coordenadas/estados
     * atualizados.
     */
    public void renderizar() {
        Graphics g = getBufferStrategy().getDrawGraphics();
        Graphics2D g2 = (Graphics2D) g;
        //Limpando a tela

        // Gerando um gradiente que ficara' como cor de fundo
        //GradientPaint gp = new GradientPaint(25, 25, Color.white,50, 50, Color.RED, true);
        //g2.setPaint(gp);

        // ou pintando com uma cor definida por RGB
        Color c = new Color(255, 210, 174);
        g2.setColor(c);
        g2.fillRect(0, 0, getWidth(), getHeight());

        // desenhar cenario de fundo
        this.renderizarCenario(g2);

        // desenhando os elementos nao nulos
        if (this.jog1 != null) {
            this.jog1.desenhar(g2);
        }
        if (this.jog2 != null) {
            this.jog2.desenhar(g2);
        }

        //liberando os contextos gráficos
        g.dispose();
        g2.dispose();

    }

    /**
     * Efetuando a troca das areas de desenho e apresentacao. 
     * No metodo redenrizar os elemtos graficos foram desenhados em um buffer
     * secundario, agora iremos fazer com que esse buffer secundario torne-se
     * primario, ou seja, que apareca de fato na tela
     */
    public void desenhar() {
        if (!getBufferStrategy().contentsLost()) {
            getBufferStrategy().show();
        }
    }

    /**
     * Fim de jogo/rodada
     */
    public void finalizar() {
        if (this.jog1.vidas == 0) {
            ganhador = "Jogador 2";
            vitorias2++;
        } else {
            ganhador = "Jogador 1";
            vitorias1++;
        }
        Recomecar rec = new Recomecar(framePrincipal, true, ganhador);
        rec.setLocationRelativeTo(this);
        rec.setVisible(true);
        if (rec.sim) {
            resetaCenario();
            comecaOJogo();
        } else {
            this.framePrincipal.setVisible(false);
        }
    }

    /**
     * Desenha o cenário com as paredes de tijolos e de ferro
     * @param g contexto gráfico
     */
    public void renderizarCenario(Graphics2D g) {
        for (int i = 0; i < 11; i++) { // linhas
            for (int j = 0; j < 17; j++) { // colunas
                if (this.cenario[i][j] != 2) { // se não for vazio, desenhe
                    g.drawImage(this.imgcenarios[this.cenario[i][j]], this.larguraBloco * j, this.larguraBloco * i, this.framePrincipal);
                }
            }
        }
    }

    /**
     * Verifica se na posicao lin,col da matriz tem um espaço vazio
     * @param lin numero da linha
     * @param col numero da coluna
     * @return true se estiver vazio, false caso contrario
     */
    public boolean estaLivre(int lin, int col) {
        return cenario[lin][col] == 2; // se for == 2, entao ira' retornar true, false caso contrario
    }

    public boolean estaLivreBomba(int lin, int col) {
        return (cenario[lin][col] > 3 && cenario[lin][col] < 5); // se for == 4, entao ira' retornar true, false caso contrario
    }

    public boolean estaLivreFogo(int lin, int col) {
        return (cenario[lin][col] > 4 && cenario[lin][col] < 6); // se for == 5, entao ira' retornar true, false caso contrario
    }
    public boolean estaLivreRato(int lin, int col) {
        return (cenario[lin][col] > 5 && cenario[lin][col] < 7); // se for == 7, entao ira' retornar true, false caso contrario
    }
    public boolean estaLivreGato(int lin, int col) {
        return (cenario[lin][col] > 6 && cenario[lin][col] < 8); // se for == 7, entao ira' retornar true, false caso contrario
    }
    public boolean estaLivreVida(int lin, int col) {
        return (cenario[lin][col] > 7 && cenario[lin][col] < 9); // se for == 7, entao ira' retornar true, false caso contrario
    }

    /**
     * Indica em que posicao na tela encontrase o inicio dessa o retangulo que 
     * compreende uma celula
     * @param celula posicao na matriz que deseja-se descobrir
     * @return Coordenada na tela
     */
    public int celulaParaPixel(int celula) {
        return larguraBloco * celula;

    }

    /**
     * Indica qual celula o pixel esta' contido na matriz
     * @param pixel
     * @return 
     */
    public int pixelParaCelula(int pixel) {
        return pixel / larguraBloco;
    }

    public void resetaCenario() {
        short[][] cenarioBase = { //11x17 (linha,coluna)
            {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
            {0, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 0},
            {0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0},
            {0, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 0},
            {0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0},
            {0, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 0},
            {0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0},
            {0, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 0},
            {0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 0},
            {0, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 0},
            {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
        };
        cenario = cenarioBase;
    }

    public void cenarioAleatorio() {
        resetaCenario();
        int a;
        int b;
        for (int i = 0; i < 80; i++) {
            a = aleatorio.nextInt(11);
            b = aleatorio.nextInt(17);
            if (this.cenario[a][b] == 2) {
                this.cenario[a][b] = 1;

            } else {
                i--;
            }
        }
        this.cenario[1][1] = 2;
        this.cenario[2][1] = 2;
        this.cenario[1][2] = 2;
        this.cenario[9][15] = 2;
        this.cenario[8][15] = 2;
        this.cenario[9][14] = 2;
        poderesAleatorios();
    }

    public void poderesAleatorios() {
        for (int u = 0; u < 30; u++) {
            int c;
            int d;
            c = aleatorio.nextInt(11);
            d = aleatorio.nextInt(17);

            if (this.cenario[c][d] == 1) {
                this.cenario[c][d] = 3;
            } else {
                u--;
            }
        }
    }

    public void verificaPoder(int y, int x) {
        if (this.cenario[y][x] == 3) {
        }
    }

    public void jogadorAtingido(int bX, int bY) {
        if ((this.jog1.matColuna == bX && this.jog1.matLinha == bY) && jog1.morrendo == 0) {
            jog1.morrendo = 200;
            jog1.vidas--;
        }
        if ((this.jog2.matColuna == bX && this.jog2.matLinha == bY) && jog2.morrendo == 0) {
            jog2.morrendo = 200;
            jog2.vidas--;
        }
    }
}
